diff --git a/java/yb-client/src/test/java/org/yb/minicluster/LogErrorListener.java b/java/yb-client/src/test/java/org/yb/minicluster/LogErrorListener.java
index 1be83687a5de..087920c7c6fd 100644
--- a/java/yb-client/src/test/java/org/yb/minicluster/LogErrorListener.java
+++ b/java/yb-client/src/test/java/org/yb/minicluster/LogErrorListener.java
@@ -27,7 +27,7 @@ public interface LogErrorListener {
   /**
    * This is called when a {@link LogPrinter} is begin initialized that has been given this instance
    * of a {@link LogErrorListener}. This allows us to detect cases when the same log listener
-   * is being associated with multiple log printers, which is not allowed.pg
+   * is being associated with multiple log printers, which is not allowed.
    * @param printer log printer instance
    */
   void associateWithLogPrinter(LogPrinter printer);
diff --git a/java/yb-client/src/test/java/org/yb/minicluster/LogPrinter.java b/java/yb-client/src/test/java/org/yb/minicluster/LogPrinter.java
index df64bb20134f..600892c71616 100644
--- a/java/yb-client/src/test/java/org/yb/minicluster/LogPrinter.java
+++ b/java/yb-client/src/test/java/org/yb/minicluster/LogPrinter.java
@@ -20,6 +20,8 @@
 import java.io.IOException;
 import java.io.InputStream;
 import java.io.InputStreamReader;
+import java.util.ArrayList;
+import java.util.List;
 import java.util.concurrent.atomic.AtomicBoolean;
 import java.util.concurrent.atomic.AtomicLong;
 
@@ -33,14 +35,17 @@ public class LogPrinter {
 
   private static final Logger LOG = LoggerFactory.getLogger(MiniYBDaemon.class);
 
+  private static final AtomicLong totalLoggedSize = new AtomicLong();
+  private static final AtomicBoolean logSizeExceededThrown = new AtomicBoolean(false);
+
   private final String logPrefix;
   private final InputStream stream;
   private final Thread thread;
   private final AtomicBoolean stopRequested = new AtomicBoolean(false);
   private final Object stopper = new Object();
 
-  private static final AtomicLong totalLoggedSize = new AtomicLong();
-  private static final AtomicBoolean logSizeExceededThrown = new AtomicBoolean(false);
+  /** A mechanism to wait for a line in the log that says that the server is starting. */
+  private final List<LogErrorListener> errorListeners = new ArrayList<>();
 
   private boolean stopped = false;
   private String errorMessage;
@@ -52,9 +57,6 @@ public class LogPrinter {
           "YB_JAVA_TEST_MAX_ALLOWED_LOG_BYTES",
           512 * 1024 * 1024);
 
-  // A mechanism to wait for a line in the log that says that the server is starting.
-  private LogErrorListener errorListener;
-
   public LogPrinter(InputStream stream, String logPrefix) {
     this(stream, logPrefix, null);
   }
@@ -64,9 +66,8 @@ public LogPrinter(InputStream stream, String logPrefix, LogErrorListener errorLi
 
     this.logPrefix = logPrefix;
     this.thread = new Thread(() -> runThread());
-    this.errorListener = errorListener;
     if (errorListener != null) {
-      errorListener.associateWithLogPrinter(this);
+      addErrorListener(errorListener);
     }
 
     thread.setDaemon(true);
@@ -74,14 +75,26 @@ public LogPrinter(InputStream stream, String logPrefix, LogErrorListener errorLi
     thread.start();
   }
 
+  public void addErrorListener(LogErrorListener errorListener) {
+    if (stopRequested.get()) {
+      return;
+    }
+    synchronized (errorListeners) {
+      errorListener.associateWithLogPrinter(this);
+      this.errorListeners.add(errorListener);
+    }
+  }
+
   private String logPrinterName() {
     return "Log printer for '" + logPrefix.trim() + "'";
   }
 
-  // To be used for logging with prefix.
-  // Returns message prefixed with logPrinterName() if called not from log printer thread.
-  // No need to have a prefix when called from log printer thread, since thread name is included
-  // in log anyway.
+  /**
+   * To be used for logging with prefix.
+   * Returns message prefixed with logPrinterName() if called not from log printer thread.
+   * No need to have a prefix when called from log printer thread, since thread name is included
+   * in log anyway.
+   */
   private String withPrefix(String message) {
     if (Thread.currentThread().equals(thread)) {
       return message;
@@ -101,8 +114,10 @@ private void runThread() {
         try {
           while (!stopRequested.get()) {
             while ((line = in.readLine()) != null) {
-              if (errorListener != null) {
-                errorListener.handleLine(line);
+              synchronized (errorListeners) {
+                for (LogErrorListener l : errorListeners) {
+                  l.handleLine(line);
+                }
               }
               System.out.println(logPrefix + line);
               if (totalLoggedSize.addAndGet(line.length() + 1) > MAX_ALLOWED_LOGGED_BYTES) {
@@ -172,8 +187,11 @@ public void stop() throws InterruptedException {
         stopper.wait();
       }
     }
-    if (errorListener != null) {
-      errorListener.reportErrorsAtEnd();
+
+    synchronized (errorListeners) {
+      for (LogErrorListener l : errorListeners) {
+        l.reportErrorsAtEnd();
+      }
     }
   }
 
diff --git a/java/yb-cql/src/test/java/org/yb/cql/TestAudit.java b/java/yb-cql/src/test/java/org/yb/cql/TestAudit.java
new file mode 100644
index 000000000000..b0582a5c4b0c
--- /dev/null
+++ b/java/yb-cql/src/test/java/org/yb/cql/TestAudit.java
@@ -0,0 +1,577 @@
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+//
+package org.yb.cql;
+
+import static org.yb.AssertionWrappers.*;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Map.Entry;
+import java.util.Objects;
+import java.util.Optional;
+import java.util.stream.Collectors;
+
+import org.apache.commons.lang3.StringUtils;
+import org.apache.commons.lang3.time.StopWatch;
+import org.junit.After;
+import org.junit.Before;
+import org.junit.Test;
+import org.junit.runner.RunWith;
+
+import org.yb.YBTestRunner;
+import org.yb.client.TestUtils;
+import org.yb.minicluster.LogErrorListener;
+import org.yb.minicluster.LogPrinter;
+import org.yb.minicluster.MiniYBDaemon;
+
+import com.datastax.driver.core.BatchStatement;
+import com.datastax.driver.core.BoundStatement;
+import com.datastax.driver.core.Cluster;
+import com.datastax.driver.core.PreparedStatement;
+import com.datastax.driver.core.Session;
+import com.datastax.driver.core.SimpleStatement;
+import com.google.common.net.HostAndPort;
+
+@RunWith(value = YBTestRunner.class)
+public class TestAudit extends BaseCQLTest {
+
+  @Override
+  protected Map<String, String> getTServerFlags() {
+    Map<String, String> flags = super.getTServerFlags();
+    flags.put("use_cassandra_authentication", "true");
+    return flags;
+  }
+
+  @Override
+  public Cluster.Builder getDefaultClusterBuilder() {
+    return super.getDefaultClusterBuilder().withCredentials("cassandra", "cassandra");
+  }
+
+  @Before
+  public void createRolesAndInitLogListeners() throws Exception {
+    for (Entry<HostAndPort, MiniYBDaemon> entry : miniCluster.getTabletServers().entrySet()) {
+      int port = entry.getKey().getPort();
+      MiniYBDaemon tserver = entry.getValue();
+      tserver.getLogPrinter().addErrorListener(new AuditLogListener(port));
+    }
+    session.execute("CREATE ROLE user1 WITH login = true AND password = '123'");
+
+    AuditConfig config = new AuditConfig();
+    config.enabled = true;
+    applyAuditConfig(config);
+    discardAuditRecords();
+  }
+
+  @After
+  public void dropRoles() throws Exception {
+    session.execute("DROP ROLE user1");
+  }
+
+  @Test
+  public void auth() throws Exception {
+    try (Session session = getSession("user1", "123")) {
+      List<AuditLogEntry> records = fetchNewAuditRecords();
+      List<AuditLogEntry> authRecords = records.stream()
+          .filter(e -> e.category.equals("AUTH"))
+          .collect(Collectors.toList());
+      assertEquals(4, authRecords.size()); // 3 nodes + 1 control connection
+      for (AuditLogEntry s : authRecords) {
+        assertEquals("LOGIN_SUCCESS", s.type);
+      }
+    }
+
+    try (Session session = getSession("user1", "321")) {
+      fail("These credentials should be invalid!");
+    } catch (com.datastax.driver.core.exceptions.AuthenticationException ex) {
+      List<AuditLogEntry> records = fetchNewAuditRecords();
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "null", "LOGIN_ERROR", "AUTH",
+                  null /* batchId */, null /* keyspace */, null /* scope */,
+                  "LOGIN FAILURE; Provided username user1 and/or password are incorrect")),
+          records);
+    } catch (Exception ex) {
+      throw ex;
+    }
+  }
+
+  /** Issuing DML batch as YCQL plaintext: {@code START TXN; DML1; DML2; COMMIT} */
+  @Test
+  public void batchPlaintext() throws Exception {
+    session.execute("CREATE TABLE batch_t (id int PRIMARY KEY)"
+        + " WITH transactions = {'enabled': 'true'}");
+    discardAuditRecords();
+
+    String startTxnCql = "START TRANSACTION";
+    String insertCql = "INSERT INTO batch_t (id) VALUES (1)";
+    String commitCql = "COMMIT";
+
+    // Execute as one-liner.
+    {
+      String oneLinerCql = StringUtils.joinWith("; ", startTxnCql, insertCql, insertCql, commitCql);
+      session.execute(oneLinerCql);
+      List<AuditLogEntry> records = fetchNewAuditRecords();
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "BATCH", "DML",
+                  null /* batchId */, null /* keyspace */, null /* scope */,
+                  oneLinerCql)),
+          records);
+    }
+
+    // Execute line by line.
+    // Batch request ID is not present in this case.
+    // (For Cassandra, using BEGIN BATCH in this way is grammatically incorrect)
+    {
+      session.execute(startTxnCql);
+      session.execute(insertCql);
+      session.execute(insertCql);
+      session.execute(commitCql);
+      List<AuditLogEntry> records = fetchNewAuditRecords();
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "BATCH", "DML",
+                  null /* batchId */, null /* keyspace */, null /* scope */,
+                  startTxnCql),
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "batch_t",
+                  insertCql),
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "batch_t",
+                  insertCql),
+              new AuditLogEntry('E', "cassandra", "BATCH", "DML",
+                  null /* batchId */, null /* keyspace */, null /* scope */,
+                  commitCql)),
+          records);
+    }
+  }
+
+  /** Issuing DML batch as driver-level {@code BatchStatement} */
+  @Test
+  public void batchDriverStatement() throws Exception {
+    session.execute("CREATE TABLE batch_t (id int PRIMARY KEY)"
+        + " WITH transactions = {'enabled': 'true'}");
+    discardAuditRecords();
+
+    String insertCql = "INSERT INTO batch_t (id) VALUES (1)";
+    String insertPrepCql = "INSERT INTO batch_t (id) VALUES (?)";
+
+    PreparedStatement preparedInsert = session.prepare(insertPrepCql);
+    BatchStatement batch = new BatchStatement()
+        .add(new SimpleStatement(insertCql))
+        .add(preparedInsert.bind(2))
+        .add(preparedInsert.bind(3));
+
+    session.execute(batch);
+
+    // Three PREPARE calls (one per tserver), three UPDATEs
+
+    List<AuditLogEntry> records = fetchNewAuditRecords();
+    String batchId = getBatchId(records);
+
+    AuditLogEntry prepareEntry = new AuditLogEntry('E', "cassandra", "PREPARE_STATEMENT", "PREPARE",
+        null /* batchId */, DEFAULT_TEST_KEYSPACE, "batch_t",
+        insertPrepCql);
+    assertEquals(
+        Arrays.asList(
+            prepareEntry, prepareEntry, prepareEntry,
+            new AuditLogEntry('E', "cassandra", "BATCH", "DML",
+                batchId, null /* keyspace */, null /* scope */,
+                "BatchId:[" + batchId + "] - BATCH of [3] statements"),
+            new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                batchId, DEFAULT_TEST_KEYSPACE, "batch_t",
+                insertCql),
+            new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                batchId, DEFAULT_TEST_KEYSPACE, "batch_t",
+                insertPrepCql),
+            new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                batchId, DEFAULT_TEST_KEYSPACE, "batch_t",
+                insertPrepCql)),
+        records);
+  }
+
+  /** Verifies that driver-level batch request with stale metadata works. */
+  @Test
+  public void batchWithStaleMetadata() throws Exception {
+    {
+      session.execute("CREATE TABLE test_batch (h INT, r BIGINT, PRIMARY KEY ((h), r))");
+      discardAuditRecords();
+
+      String insertCql = "INSERT INTO test_batch (h, r) VALUES (1, 1)";
+
+      BatchStatement batch = new BatchStatement();
+      batch.add(new SimpleStatement("INSERT INTO test_batch (h, r) VALUES (1, 1)"));
+      session.execute(batch);
+
+      List<AuditLogEntry> records = fetchNewAuditRecords();
+      String batchId = getBatchId(records);
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "BATCH", "DML",
+                  batchId, null /* keyspace */, null /* scope */,
+                  "BatchId:[" + batchId + "] - BATCH of [1] statements"),
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  batchId, DEFAULT_TEST_KEYSPACE, "test_batch",
+                  insertCql)),
+          records);
+    }
+
+    {
+      session.execute("DROP TABLE test_batch");
+      session.execute("CREATE TABLE test_batch (h INT, r TEXT, PRIMARY KEY ((h), r))");
+      discardAuditRecords();
+
+      String insertCql = "INSERT INTO test_batch (h, r) VALUES (1, ?)";
+
+      BatchStatement batch = new BatchStatement();
+      batch.add(new SimpleStatement(insertCql, "R" + 1));
+      session.execute(batch);
+
+      List<AuditLogEntry> records = fetchNewAuditRecords();
+      String batchId = getBatchId(records);
+      // TODO: We probably shouldn't log an error here as the user doesn't receive it.
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "BATCH", "DML",
+                  batchId, null /* keyspace */, null /* scope */,
+                  "BatchId:[" + batchId + "] - BATCH of [1] statements"),
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  batchId, DEFAULT_TEST_KEYSPACE, "test_batch",
+                  insertCql),
+              new AuditLogEntry('E', "cassandra", "REQUEST_FAILURE", "ERROR",
+                  batchId, null /* keyspace */, null /* scope */,
+                  insertCql + "; "
+                      + "Invalid Arguments. unexpected number byte length: expected 8, provided 2"),
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  batchId, DEFAULT_TEST_KEYSPACE, "test_batch",
+                  insertCql)),
+          records);
+    }
+  }
+
+  @Test
+  public void dmlAndQuery() throws Exception {
+    session.execute("CREATE TABLE t (id int PRIMARY KEY, v text)");
+    discardAuditRecords();
+
+    // INSERT
+    {
+      String insertCql = "INSERT INTO t (id, v) VALUES (1, 'v1')";
+      session.execute(insertCql);
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  insertCql)),
+          fetchNewAuditRecords());
+    }
+
+    // INSERT (prepared)
+    {
+      String insertBindCql = "INSERT INTO t (id, v) VALUES (?, ?)";
+      BoundStatement bound = session.prepare(insertBindCql).bind(1, "v1-1");
+      assertEquals(
+          Collections.nCopies(3 /* One per node */,
+              new AuditLogEntry('E', "cassandra", "PREPARE_STATEMENT", "PREPARE",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  insertBindCql)),
+          fetchNewAuditRecords());
+      session.execute(bound);
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  insertBindCql)),
+          fetchNewAuditRecords());
+    }
+
+    // SELECT
+    {
+      String selectCql = "SELECT * FROM t";
+      assertQueryRowsOrdered(selectCql, "Row[1, v1-1]");
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "SELECT", "QUERY",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  selectCql)),
+          fetchNewAuditRecords());
+    }
+
+    // UPDATE
+    {
+      String updateCql = "UPDATE t SET v = 'v1-2' WHERE id = 1";
+      session.execute(updateCql);
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "UPDATE", "DML",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  updateCql)),
+          fetchNewAuditRecords());
+    }
+
+    // SELECT (prepared)
+    {
+      String selectCql = "SELECT id, v FROM t WHERE id = ?";
+      BoundStatement bound = session.prepare(selectCql).bind(1);
+      assertEquals(
+          Collections.nCopies(3 /* One per node */,
+              new AuditLogEntry('E', "cassandra", "PREPARE_STATEMENT", "PREPARE",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  selectCql)),
+          fetchNewAuditRecords());
+      assertQueryRowsOrdered(bound, Arrays.asList("Row[1, v1-2]"));
+      assertEquals(
+          Arrays.asList(
+              new AuditLogEntry('E', "cassandra", "SELECT", "QUERY",
+                  null /* batchId */, DEFAULT_TEST_KEYSPACE, "t",
+                  selectCql)),
+          fetchNewAuditRecords());
+    }
+  }
+
+  // FIXME: log level, KS, cat, user
+
+  //
+  // Helpers
+  //
+
+  private Session getSession(String username, String password) {
+    Cluster.Builder cb = getDefaultClusterBuilder().withCredentials(username, password);
+    Cluster c = cb.build();
+    Session s = c.connect();
+    return s;
+  }
+
+  private List<AuditLogEntry> auditRecords = Collections.synchronizedList(new ArrayList<>());
+
+  /** Discard existing audit records so that only newer ones will be retrieved. */
+  private void discardAuditRecords() throws Exception {
+    Thread.sleep(100);
+    auditRecords.clear();
+  }
+
+  /** Retrieve the audit records added to the log since last call. */
+  private List<AuditLogEntry> fetchNewAuditRecords() throws Exception {
+    Thread.sleep(100);
+    synchronized (auditRecords) {
+      List<AuditLogEntry> result = new ArrayList<>(auditRecords);
+      auditRecords.clear();
+      return result;
+    }
+  }
+
+  private String getBatchId(List<AuditLogEntry> records) throws Exception {
+    Optional<String> batchIdOpt = records.stream()
+        .filter(e -> e.type.equals("BATCH")).map(e -> e.batchId).findFirst();
+    assertTrue("No BATCH requests were present! Audit: " + records, batchIdOpt.isPresent());
+    return batchIdOpt.get();
+  }
+
+  private void runProcess(List<String> args) throws Exception {
+    assertEquals(0, new ProcessBuilder(args).start().waitFor());
+  }
+
+  /**
+   * Applies non-null values from the given audit config to all tservers. Null values are not
+   * changed.
+   */
+  private void applyAuditConfig(AuditConfig config) throws Exception {
+    StopWatch sw = StopWatch.createStarted();
+    List<String> processArgs = Arrays.asList(
+        TestUtils.findBinary("yb-ts-cli"),
+        "--server_address",
+        "<PLACEHOLDER>",
+        "set_flag",
+        "<PLACEHOLDER>",
+        "<PLACEHOLDER>");
+    for (HostAndPort server : miniCluster.getTabletServers().keySet()) {
+      processArgs.set(2, server.toString());
+      for (Entry<String, String> entry : config.getGflags().entrySet()) {
+        processArgs.set(4, entry.getKey());
+        processArgs.set(5, entry.getValue());
+        runProcess(processArgs);
+      }
+    }
+    LOG.info("Audit config applied in " + sw.getTime() + " ms");
+  }
+
+  /**
+   * Helper class for audit gflag configuration.
+   * <p>
+   * Null values mean that gflag should be removed.
+   */
+  private static class AuditConfig {
+    public boolean enabled;
+    public String logLevel;
+    public String includedKeyspaces;
+    public String excludedKeyspaces;
+    public String includedCategories;
+    public String excludedCategories;
+    public String includedUsers;
+    public String excludedUsers;
+
+    public Map<String, String> getGflags() {
+      Map<String, String> map = new LinkedHashMap<>();
+      map.put("ycql_enable_audit_log", Boolean.toString(enabled));
+      map.put("ycql_audit_log_level", logLevel);
+      map.put("ycql_audit_included_keyspaces", includedKeyspaces);
+      map.put("ycql_audit_excluded_keyspaces", excludedKeyspaces);
+      map.put("ycql_audit_included_categories", includedCategories);
+      map.put("ycql_audit_excluded_categories", excludedCategories);
+      map.put("ycql_audit_included_users", includedUsers);
+      map.put("ycql_audit_excluded_users", excludedUsers);
+      map.values().removeIf(v -> v == null);
+      return map;
+    }
+  }
+
+  private class AuditLogListener implements LogErrorListener {
+    private final String PREFIX = "AUDIT: ";
+
+    public final int tserverPort;
+
+    public AuditLogListener(int tserverPort) {
+      this.tserverPort = tserverPort;
+    }
+
+    @Override
+    public void associateWithLogPrinter(LogPrinter printer) {
+      // NOOP
+    }
+
+    @Override
+    public void reportErrorsAtEnd() {
+      // NOOP
+    }
+
+    @Override
+    public void handleLine(String line) {
+      int idx = line.indexOf(PREFIX);
+      if (idx == -1) {
+        return;
+      }
+
+      AuditLogEntry entry = new AuditLogEntry();
+      entry.tserverPort = tserverPort;
+      entry.logLevel = line.charAt(0);
+
+      // This would slip if an operation contains "|" character but we just won't issue those.
+      String rest = line.substring(idx + PREFIX.length());
+      for (String part : rest.split("\\|")) {
+        String[] partsOfPart = part.split(":", 2);
+        switch (partsOfPart[0]) {
+          case "user":
+            entry.user = partsOfPart[1];
+            break;
+          case "host":
+            entry.host = partsOfPart[1];
+            break;
+          case "source":
+            entry.source = partsOfPart[1];
+            break;
+          case "port":
+            entry.source += ":" + partsOfPart[1];
+            break;
+          case "timestamp":
+            entry.timestamp = partsOfPart[1];
+            break;
+          case "type":
+            entry.type = partsOfPart[1];
+            break;
+          case "category":
+            entry.category = partsOfPart[1];
+            break;
+          case "batch":
+            entry.batchId = partsOfPart[1];
+            break;
+          case "ks":
+            entry.keyspace = partsOfPart[1];
+            break;
+          case "scope":
+            entry.scope = partsOfPart[1];
+            break;
+          case "operation":
+            entry.operationAndErrorMessage = partsOfPart[1];
+            break;
+          default:
+            throw new IllegalStateException("Unexpected prefix " + partsOfPart[0]
+                + ", line: " + line);
+        }
+      }
+      auditRecords.add(entry);
+    }
+  }
+
+  private static class AuditLogEntry {
+    public Character logLevel;
+    public int tserverPort;
+    public String user;
+    public String host;
+    public String source;
+    public String timestamp;
+    public String type;
+    public String category;
+    public String batchId;
+    public String keyspace;
+    public String scope;
+    public String operationAndErrorMessage;
+
+    public AuditLogEntry() {
+    }
+
+    // Auto-generated boilerplate.
+    // (Ignores tserverPort, host, source and timestamp.)
+
+    public AuditLogEntry(Character logLevel, String user, String type, String category,
+        String batchId, String keyspace, String scope, String operationAndErrorMessage) {
+      this.logLevel = logLevel;
+      this.user = user;
+      this.type = type;
+      this.category = category;
+      this.batchId = batchId;
+      this.keyspace = keyspace;
+      this.scope = scope;
+      this.operationAndErrorMessage = operationAndErrorMessage;
+    }
+
+    @Override
+    public int hashCode() {
+      return Objects.hash(batchId, category, keyspace, logLevel, operationAndErrorMessage, scope,
+          type, user);
+    }
+
+    @Override
+    public boolean equals(Object obj) {
+      if (this == obj) return true;
+      if (obj == null) return false;
+      if (getClass() != obj.getClass()) return false;
+      AuditLogEntry other = (AuditLogEntry) obj;
+      return Objects.equals(batchId, other.batchId) && Objects.equals(category, other.category)
+          && Objects.equals(keyspace, other.keyspace) && Objects.equals(logLevel, other.logLevel)
+          && Objects.equals(operationAndErrorMessage, other.operationAndErrorMessage)
+          && Objects.equals(scope, other.scope) && Objects.equals(type, other.type)
+          && Objects.equals(user, other.user);
+    }
+
+    @Override
+    public String toString() {
+      return "AuditLogEntry [logLevel=" + logLevel + ", user=" + user + ", type=" + type
+          + ", category=" + category + ", batchId=" + batchId + ", keyspace=" + keyspace
+          + ", scope=" + scope + ", operationAndErrorMessage=" + operationAndErrorMessage + "]";
+    }
+  }
+}
diff --git a/src/yb/util/string_util.cc b/src/yb/util/string_util.cc
index 968b875071dd..16e9d06818ec 100644
--- a/src/yb/util/string_util.cc
+++ b/src/yb/util/string_util.cc
@@ -58,7 +58,7 @@ vector<string> StringSplit(const string& arg, char delim) {
   stringstream ss(arg);
   string item;
   while (getline(ss, item, delim)) {
-    splits.push_back(item);
+    splits.push_back(std::move(item));
   }
   return splits;
 }
diff --git a/src/yb/yql/cql/cqlserver/cql_message.h b/src/yb/yql/cql/cqlserver/cql_message.h
index 40f44e9683d0..c7cce9f7f235 100644
--- a/src/yb/yql/cql/cqlserver/cql_message.h
+++ b/src/yb/yql/cql/cqlserver/cql_message.h
@@ -528,6 +528,10 @@ class ErrorResponse : public CQLResponse {
 
   virtual ~ErrorResponse() override;
 
+  const std::string& message() const {
+    return message_;
+  }
+
  protected:
   virtual void SerializeBody(faststring* mesg) const override;
   virtual void SerializeErrorBody(faststring* mesg) const;
diff --git a/src/yb/yql/cql/cqlserver/cql_processor.cc b/src/yb/yql/cql/cqlserver/cql_processor.cc
index 309f4161f0ac..f57c56b4068d 100644
--- a/src/yb/yql/cql/cqlserver/cql_processor.cc
+++ b/src/yb/yql/cql/cqlserver/cql_processor.cc
@@ -95,6 +95,7 @@ constexpr const char* const kCassandraPasswordAuthenticator =
 extern const char* const kRoleColumnNameSaltedHash;
 extern const char* const kRoleColumnNameCanLogin;
 
+using std::make_unique;
 using std::shared_ptr;
 using std::unique_ptr;
 
@@ -170,6 +171,7 @@ void CQLProcessor::Shutdown() {
 
 void CQLProcessor::ProcessCall(rpc::InboundCallPtr call) {
   call_ = std::dynamic_pointer_cast<CQLInboundCall>(std::move(call));
+  audit_logger_.SetConnection(call_->connection());
   unique_ptr<CQLRequest> request;
   unique_ptr<CQLResponse> response;
 
@@ -193,7 +195,7 @@ void CQLProcessor::ProcessCall(rpc::InboundCallPtr call) {
   request_ = std::move(request);
   call_->SetRequest(request_, service_impl_);
   retry_count_ = 0;
-  response.reset(ProcessRequest(*request_));
+  response = ProcessRequest(*request_);
   PrepareAndSendResponse(response);
 }
 
@@ -203,6 +205,7 @@ void CQLProcessor::Release() {
   stmts_.clear();
   parse_trees_.clear();
   SetCurrentSession(nullptr);
+  audit_logger_.SetConnection(nullptr);
   service_impl_->ReturnProcessor(pos_);
 }
 
@@ -238,7 +241,7 @@ void CQLProcessor::SendResponse(const CQLResponse& response) {
   Release();
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const CQLRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const CQLRequest& req) {
   switch (req.opcode()) {
     case CQLMessage::Opcode::OPTIONS:
       return ProcessRequest(static_cast<const OptionsRequest&>(req));
@@ -272,11 +275,11 @@ CQLResponse* CQLProcessor::ProcessRequest(const CQLRequest& req) {
   return nullptr;
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const OptionsRequest& req) {
-  return new SupportedResponse(req, &kSupportedOptions);
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const OptionsRequest& req) {
+  return make_unique<SupportedResponse>(req, &kSupportedOptions);
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const StartupRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const StartupRequest& req) {
   for (const auto& option : req.options()) {
     const auto& name = option.first;
     const auto& value = option.second;
@@ -292,20 +295,20 @@ CQLResponse* CQLProcessor::ProcessRequest(const StartupRequest& req) {
       } else if (value == CQLMessage::kSnappyCompression) {
         context.set_compression_scheme(CQLMessage::CompressionScheme::kSnappy);
       } else {
-        return new ErrorResponse(
+        return make_unique<ErrorResponse>(
             req, ErrorResponse::Code::PROTOCOL_ERROR,
             Substitute("Unsupported compression scheme $0", value));
       }
     }
   }
   if (FLAGS_use_cassandra_authentication) {
-    return new AuthenticateResponse(req, kCassandraPasswordAuthenticator);
+    return make_unique<AuthenticateResponse>(req, kCassandraPasswordAuthenticator);
   } else {
-    return new ReadyResponse(req);
+    return make_unique<ReadyResponse>(req);
   }
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const PrepareRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const PrepareRequest& req) {
   VLOG(1) << "PREPARE " << req.query();
   const CQLMessage::QueryId query_id = CQLStatement::GetQueryId(
       ql_env_.CurrentKeyspace(), req.query());
@@ -318,18 +321,33 @@ CQLResponse* CQLProcessor::ProcessRequest(const PrepareRequest& req) {
   shared_ptr<CQLStatement> stmt = service_impl_->AllocatePreparedStatement(
       query_id, ql_env_.CurrentKeyspace(), req.query());
   PreparedResult::UniPtr result;
-  const Status s = stmt->Prepare(this, service_impl_->prepared_stmts_mem_tracker(),
-                                 false /* internal */, &result);
+  Status s = stmt->Prepare(this, service_impl_->prepared_stmts_mem_tracker(),
+                           false /* internal */, &result);
+
+  if (s.ok()) {
+    auto pt_result = stmt->GetParseTree();
+    if (pt_result.ok()) {
+      s = audit_logger_.LogStatement(pt_result->root().get(), req.query(),
+                                     true /* is_prepare */);
+    } else {
+      s = pt_result.status();
+    }
+  } else {
+    WARN_NOT_OK(audit_logger_.LogStatementError(req.query(), s,
+                                                true /* error_is_formatted */),
+                "Failed to log an audit record");
+  }
+
   if (!s.ok()) {
     service_impl_->DeletePreparedStatement(stmt);
     return ProcessError(s, stmt->query_id());
   }
 
-  return (result != nullptr) ? new PreparedResultResponse(req, query_id, *result)
-                             : new PreparedResultResponse(req, query_id);
+  return (result != nullptr) ? make_unique<PreparedResultResponse>(req, query_id, *result)
+                             : make_unique<PreparedResultResponse>(req, query_id);
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const ExecuteRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const ExecuteRequest& req) {
   VLOG(1) << "EXECUTE " << b2a_hex(req.query_id());
   const shared_ptr<const CQLStatement> stmt = GetPreparedStatement(req.query_id());
   if (stmt == nullptr) {
@@ -339,7 +357,7 @@ CQLResponse* CQLProcessor::ProcessRequest(const ExecuteRequest& req) {
   return s.ok() ? nullptr : ProcessError(s, stmt->query_id());
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const QueryRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const QueryRequest& req) {
   VLOG(1) << "QUERY " << req.query();
   if (service_impl_->system_cache() != nullptr) {
     auto cached_response = service_impl_->system_cache()->Lookup(req.query());
@@ -355,12 +373,19 @@ CQLResponse* CQLProcessor::ProcessRequest(const QueryRequest& req) {
   return nullptr;
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const BatchRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const BatchRequest& req) {
   VLOG(1) << "BATCH " << req.queries().size();
 
   StatementBatch batch;
   batch.reserve(req.queries().size());
 
+  // If no errors happen, batch request started here will be ended by the executor.
+  Status s = audit_logger_.StartBatchRequest(req.queries().size());
+  if (PREDICT_FALSE(!s.ok())) {
+    return ProcessError(s);
+  }
+
+  unique_ptr<CQLResponse> result;
   // For each query in the batch, look up the query id if it is a prepared statement, or prepare the
   // query if it is not prepared. Then execute the parse trees with the parameters.
   for (const BatchRequest::Query& query : req.queries()) {
@@ -368,52 +393,64 @@ CQLResponse* CQLProcessor::ProcessRequest(const BatchRequest& req) {
       VLOG(1) << "BATCH EXECUTE " << b2a_hex(query.query_id);
       const shared_ptr<const CQLStatement> stmt = GetPreparedStatement(query.query_id);
       if (stmt == nullptr) {
-        return ProcessError(ErrorStatus(ErrorCode::UNPREPARED_STATEMENT), query.query_id);
+        result = ProcessError(ErrorStatus(ErrorCode::UNPREPARED_STATEMENT), query.query_id);
+        break;
       }
       const Result<const ParseTree&> parse_tree = stmt->GetParseTree();
       if (!parse_tree) {
-        return ProcessError(parse_tree.status(), query.query_id);
+        result = ProcessError(parse_tree.status(), query.query_id);
+        break;
       }
       batch.emplace_back(*parse_tree, query.params);
     } else {
       VLOG(1) << "BATCH QUERY " << query.query;
       ParseTree::UniPtr parse_tree;
-      const Status s = Prepare(query.query, &parse_tree);
+      s = Prepare(query.query, &parse_tree);
       if (PREDICT_FALSE(!s.ok())) {
-        return ProcessError(s);
+        result = ProcessError(s);
+        break;
       }
       batch.emplace_back(*parse_tree, query.params);
       parse_trees_.insert(std::move(parse_tree));
     }
   }
 
+  if (result) {
+    s = audit_logger_.EndBatchRequest();
+    // Otherwise, batch request will be ended by the executor or when processing an error.
+    if (PREDICT_FALSE(!s.ok())) {
+      result = ProcessError(s);
+    }
+    return result;
+  }
+
   ExecuteAsync(batch, statement_executed_cb_);
 
   return nullptr;
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const AuthResponseRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const AuthResponseRequest& req) {
   const auto& params = req.params();
   shared_ptr<Statement> stmt = service_impl_->GetAuthPreparedStatement();
   if (!stmt->Prepare(this, nullptr /* memtracker */, true /* internal */).ok()) {
-    return new ErrorResponse(
+    return make_unique<ErrorResponse>(
         req, ErrorResponse::Code::SERVER_ERROR,
         "Could not prepare statement for querying user " + params.username);
   }
   if (!stmt->ExecuteAsync(this, params, statement_executed_cb_).ok()) {
     LOG(ERROR) << "Could not execute prepared statement to fetch login info!";
-    return new ErrorResponse(
+    return make_unique<ErrorResponse>(
         req, ErrorResponse::Code::SERVER_ERROR,
         "Could not execute prepared statement for querying roles for user " + params.username);
   }
   return nullptr;
 }
 
-CQLResponse* CQLProcessor::ProcessRequest(const RegisterRequest& req) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessRequest(const RegisterRequest& req) {
   CQLConnectionContext& context =
       static_cast<CQLConnectionContext&>(call_->connection()->context());
   context.add_registered_events(req.events());
-  return new ReadyResponse(req);
+  return make_unique<ReadyResponse>(req);
 }
 
 shared_ptr<const CQLStatement> CQLProcessor::GetPreparedStatement(const CQLMessage::QueryId& id) {
@@ -427,11 +464,15 @@ shared_ptr<const CQLStatement> CQLProcessor::GetPreparedStatement(const CQLMessa
 
 void CQLProcessor::StatementExecuted(const Status& s, const ExecutedResult::SharedPtr& result) {
   unique_ptr<CQLResponse> response(s.ok() ? ProcessResult(result) : ProcessError(s));
+  if (response && !s.ok()) {
+    // Error response means we're not going to be transparently restarting a query.
+    WARN_NOT_OK(audit_logger_.EndBatchRequest(), "Failed to end batch request");
+  }
   PrepareAndSendResponse(response);
 }
 
-CQLResponse* CQLProcessor::ProcessError(const Status& s,
-                                        boost::optional<CQLMessage::QueryId> query_id) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessError(const Status& s,
+                                                   boost::optional<CQLMessage::QueryId> query_id) {
   if (s.IsQLError()) {
     ErrorCode ql_errcode = GetErrorCode(s);
     if (ql_errcode == ErrorCode::UNPREPARED_STATEMENT ||
@@ -448,7 +489,7 @@ CQLResponse* CQLProcessor::ProcessError(const Status& s,
         }
       }
       if (query_id) {
-        return new UnpreparedErrorResponse(*request_, *query_id);
+        return make_unique<UnpreparedErrorResponse>(*request_, *query_id);
       }
       // When no unprepared query id is found, it means all statements we executed were queries
       // (non-prepared statements). In that case, just retry the request (once only). The retry
@@ -460,40 +501,47 @@ CQLResponse* CQLProcessor::ProcessError(const Status& s,
         Reschedule(&process_request_task_.Bind(this));
         return nullptr;
       }
-      return new ErrorResponse(*request_, ErrorResponse::Code::INVALID,
-                               "Query failed to execute due to stale metadata cache");
+      return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::INVALID,
+                                        "Query failed to execute due to stale metadata cache");
     } else if (ql_errcode < ErrorCode::SUCCESS) {
       if (ql_errcode == ErrorCode::UNAUTHORIZED) {
-        return new ErrorResponse(*request_, ErrorResponse::Code::UNAUTHORIZED, s.ToUserMessage());
+        return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::UNAUTHORIZED,
+                                          s.ToUserMessage());
       } else if (ql_errcode > ErrorCode::LIMITATION_ERROR) {
         // System errors, internal errors, or crashes.
-        return new ErrorResponse(*request_, ErrorResponse::Code::SERVER_ERROR, s.ToUserMessage());
+        return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::SERVER_ERROR,
+                                          s.ToUserMessage());
       } else if (ql_errcode > ErrorCode::SEM_ERROR) {
         // Limitation, lexical, or parsing errors.
-        return new ErrorResponse(*request_, ErrorResponse::Code::SYNTAX_ERROR, s.ToUserMessage());
+        return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::SYNTAX_ERROR,
+                                          s.ToUserMessage());
       } else {
         // Semantic or execution errors.
-        return new ErrorResponse(*request_, ErrorResponse::Code::INVALID, s.ToUserMessage());
+        return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::INVALID,
+                                          s.ToUserMessage());
       }
     }
 
     LOG(ERROR) << "Internal error: invalid error code " << static_cast<int64_t>(GetErrorCode(s));
-    return new ErrorResponse(*request_, ErrorResponse::Code::SERVER_ERROR, "Invalid error code");
+    return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::SERVER_ERROR,
+                                      "Invalid error code");
   } else if (s.IsNotAuthorized()) {
-    return new ErrorResponse(*request_, ErrorResponse::Code::UNAUTHORIZED, s.ToUserMessage());
+    return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::UNAUTHORIZED,
+                                      s.ToUserMessage());
   }
 
-  return new ErrorResponse(*request_, ErrorResponse::Code::SERVER_ERROR, s.ToUserMessage());
+  return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::SERVER_ERROR,
+                                    s.ToUserMessage());
 }
 
-CQLResponse* CQLProcessor::ProcessResult(const ExecutedResult::SharedPtr& result) {
+unique_ptr<CQLResponse> CQLProcessor::ProcessResult(const ExecutedResult::SharedPtr& result) {
   if (result == nullptr) {
-    return new VoidResultResponse(*request_);
+    return make_unique<VoidResultResponse>(*request_);
   }
   switch (result->type()) {
     case ExecutedResult::Type::SET_KEYSPACE: {
       const auto& set_keyspace_result = static_cast<const SetKeyspaceResult&>(*result);
-      return new SetKeyspaceResultResponse(*request_, set_keyspace_result);
+      return make_unique<SetKeyspaceResultResponse>(*request_, set_keyspace_result);
     }
     case ExecutedResult::Type::ROWS: {
       const RowsResult::SharedPtr& rows_result = std::static_pointer_cast<RowsResult>(result);
@@ -502,22 +550,26 @@ CQLResponse* CQLProcessor::ProcessResult(const ExecutedResult::SharedPtr& result
       }
       switch (request_->opcode()) {
         case CQLMessage::Opcode::EXECUTE:
-          return new RowsResultResponse(down_cast<const ExecuteRequest&>(*request_), rows_result);
+          return make_unique<RowsResultResponse>(down_cast<const ExecuteRequest&>(*request_),
+                                                 rows_result);
         case CQLMessage::Opcode::QUERY:
-          return new RowsResultResponse(down_cast<const QueryRequest&>(*request_), rows_result);
+          return make_unique<RowsResultResponse>(down_cast<const QueryRequest&>(*request_),
+                                                 rows_result);
         case CQLMessage::Opcode::BATCH:
-          return new RowsResultResponse(down_cast<const BatchRequest&>(*request_), rows_result);
+          return make_unique<RowsResultResponse>(down_cast<const BatchRequest&>(*request_),
+                                                 rows_result);
 
         case CQLMessage::Opcode::AUTH_RESPONSE: {
           const auto& req = down_cast<const AuthResponseRequest&>(*request_);
           const auto& params = req.params();
           const auto row_block = rows_result->GetRowBlock();
           if (row_block->row_count() != 1) {
-            return new ErrorResponse(*request_, ErrorResponse::Code::SERVER_ERROR,
-                                     "Could not get data for " + params.username);
+            return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::SERVER_ERROR,
+                                              "Could not get data for " + params.username);
           } else {
             const auto& row = row_block->row(0);
             const auto& schema = row_block->schema();
+            unique_ptr<CQLResponse> response = nullptr;
 
             const QLValue& salted_hash_value =
                 row.column(schema.find_column(kRoleColumnNameSaltedHash));
@@ -526,19 +578,34 @@ CQLResponse* CQLProcessor::ProcessResult(const ExecutedResult::SharedPtr& result
             // Username doesn't have a password, but one is required for authentication. Return
             // an error.
             if (salted_hash_value.IsNull()) {
-              return new ErrorResponse(*request_, ErrorResponse::Code::BAD_CREDENTIALS,
+              response = make_unique<ErrorResponse>(*request_,
+                  ErrorResponse::Code::BAD_CREDENTIALS,
                   "Provided username " + params.username + " and/or password are incorrect");
+            } else {
+              const auto& saved_hash = salted_hash_value.string_value();
+              if (!service_impl_->CheckPassword(params.password, saved_hash)) {
+                response = make_unique<ErrorResponse>(*request_,
+                    ErrorResponse::Code::BAD_CREDENTIALS,
+                    "Provided username " + params.username + " and/or password are incorrect");
+              } else if (!can_login) {
+                response = make_unique<ErrorResponse>(*request_,
+                    ErrorResponse::Code::BAD_CREDENTIALS,
+                    params.username + " is not permitted to log in");
+              } else {
+                call_->ql_session()->set_current_role_name(params.username);
+                response = make_unique<AuthSuccessResponse>(*request_,
+                                                            "" /* this does not matter */);
+              }
             }
-            const auto& saved_hash = salted_hash_value.string_value();
-            if (!service_impl_->CheckPassword(params.password, saved_hash)) {
-              return new ErrorResponse(*request_, ErrorResponse::Code::BAD_CREDENTIALS,
-                  "Provided username " + params.username + " and/or password are incorrect");
-            } else if (!can_login) {
-              return new ErrorResponse(*request_, ErrorResponse::Code::BAD_CREDENTIALS,
-                                       params.username + " is not permitted to log in");
+
+            // FIXME: Logged twice, with different ports!
+            Status s = audit_logger_.LogAuthResponse(*response);
+            if (!s.ok()) {
+              return make_unique<ErrorResponse>(*request_, ErrorResponse::Code::SERVER_ERROR,
+                                                "Failed to write an audit log record");
             }
-            call_->ql_session()->set_current_role_name(params.username);
-            return new AuthSuccessResponse(*request_, "" /* this does not matter */);
+
+            return response;
           }
           break;
         }
@@ -563,13 +630,13 @@ CQLResponse* CQLProcessor::ProcessResult(const ExecutedResult::SharedPtr& result
     }
     case ExecutedResult::Type::SCHEMA_CHANGE: {
       const auto& schema_change_result = static_cast<const SchemaChangeResult&>(*result);
-      return new SchemaChangeResultResponse(*request_, schema_change_result);
+      return make_unique<SchemaChangeResultResponse>(*request_, schema_change_result);
     }
 
     // default: fall through.
   }
   LOG(ERROR) << "Internal error: unknown result type " << static_cast<int>(result->type());
-  return new ErrorResponse(
+  return make_unique<ErrorResponse>(
       *request_, ErrorResponse::Code::SERVER_ERROR, "Internal error: unknown result type");
 }
 
@@ -584,6 +651,7 @@ bool CQLProcessor::NeedReschedule() {
 void CQLProcessor::Reschedule(rpc::ThreadPoolTask* task) {
   auto messenger = service_impl_->messenger();
   DCHECK(messenger != nullptr) << "No messenger to reschedule CQL call";
+  audit_logger_.MarkRescheduled();
   messenger->ThreadPool(rpc::ServicePriority::kNormal).Enqueue(task);
 }
 
diff --git a/src/yb/yql/cql/cqlserver/cql_processor.h b/src/yb/yql/cql/cqlserver/cql_processor.h
index 28aa24ffd69c..289108b00a5f 100644
--- a/src/yb/yql/cql/cqlserver/cql_processor.h
+++ b/src/yb/yql/cql/cqlserver/cql_processor.h
@@ -81,17 +81,17 @@ class CQLProcessor : public ql::QLProcessor {
 
  private:
   // Process a CQL request.
-  CQLResponse* ProcessRequest(const CQLRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const CQLRequest& req);
 
   // Process specific CQL requests.
-  CQLResponse* ProcessRequest(const OptionsRequest& req);
-  CQLResponse* ProcessRequest(const StartupRequest& req);
-  CQLResponse* ProcessRequest(const PrepareRequest& req);
-  CQLResponse* ProcessRequest(const ExecuteRequest& req);
-  CQLResponse* ProcessRequest(const QueryRequest& req);
-  CQLResponse* ProcessRequest(const BatchRequest& req);
-  CQLResponse* ProcessRequest(const AuthResponseRequest& req);
-  CQLResponse* ProcessRequest(const RegisterRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const OptionsRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const StartupRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const PrepareRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const ExecuteRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const QueryRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const BatchRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const AuthResponseRequest& req);
+  std::unique_ptr<CQLResponse> ProcessRequest(const RegisterRequest& req);
 
   // Get a prepared statement and adds it to the set of statements currently being executed.
   std::shared_ptr<const CQLStatement> GetPreparedStatement(const CQLMessage::QueryId& id);
@@ -100,9 +100,10 @@ class CQLProcessor : public ql::QLProcessor {
   void StatementExecuted(const Status& s, const ql::ExecutedResult::SharedPtr& result = nullptr);
 
   // Process statement execution result and error.
-  CQLResponse* ProcessResult(const ql::ExecutedResult::SharedPtr& result);
-  CQLResponse* ProcessError(const Status& s,
-                            boost::optional<CQLMessage::QueryId> query_id = boost::none);
+  std::unique_ptr<CQLResponse> ProcessResult(const ql::ExecutedResult::SharedPtr& result);
+  std::unique_ptr<CQLResponse> ProcessError(
+      const Status& s,
+      boost::optional<CQLMessage::QueryId> query_id = boost::none);
 
   // Send response back to client.
   void PrepareAndSendResponse(const std::unique_ptr<CQLResponse>& response);
diff --git a/src/yb/yql/cql/ql/CMakeLists.txt b/src/yb/yql/cql/ql/CMakeLists.txt
index 2d11c1bfadfe..4a5d8ef88887 100644
--- a/src/yb/yql/cql/ql/CMakeLists.txt
+++ b/src/yb/yql/cql/ql/CMakeLists.txt
@@ -14,6 +14,7 @@
 add_subdirectory(util)
 add_subdirectory(ptree)
 add_subdirectory(parser)
+add_subdirectory(audit)
 add_subdirectory(sem)
 add_subdirectory(exec)
 add_subdirectory(test)
@@ -21,6 +22,7 @@ add_subdirectory(test)
 add_library(ql_api statement.cc ql_processor.cc)
 target_link_libraries(ql_api
                       ql_parser
+                      ql_audit
                       ql_sem
                       ql_exec
                       ql_util)
diff --git a/src/yb/yql/cql/ql/audit/CMakeLists.txt b/src/yb/yql/cql/ql/audit/CMakeLists.txt
new file mode 100644
index 000000000000..8386610940e8
--- /dev/null
+++ b/src/yb/yql/cql/ql/audit/CMakeLists.txt
@@ -0,0 +1,20 @@
+# Copyright (c) YugaByte, Inc.
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+# in compliance with the License.  You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software distributed under the License
+# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+# or implied.  See the License for the specific language governing permissions and limitations
+# under the License.
+#
+
+add_library(ql_audit
+            audit_logger.cc)
+
+target_link_libraries(ql_audit
+                      ql_parser
+                      yb_util)
+add_dependencies(ql_audit ql_parser)
diff --git a/src/yb/yql/cql/ql/audit/audit_logger.cc b/src/yb/yql/cql/ql/audit/audit_logger.cc
new file mode 100644
index 000000000000..77bfef7c93f3
--- /dev/null
+++ b/src/yb/yql/cql/ql/audit/audit_logger.cc
@@ -0,0 +1,813 @@
+//--------------------------------------------------------------------------------------------------
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+//--------------------------------------------------------------------------------------------------
+
+#include "yb/yql/cql/ql/audit/audit_logger.h"
+
+#include <boost/algorithm/string.hpp>
+#include <boost/optional/optional_io.hpp>
+#include <boost/uuid/uuid.hpp>
+#include <boost/uuid/random_generator.hpp>
+
+#include "yb/rpc/connection.h"
+#include "yb/util/date_time.h"
+#include "yb/yql/cql/ql/ptree/pt_alter_keyspace.h"
+#include "yb/yql/cql/ql/ptree/pt_alter_table.h"
+#include "yb/yql/cql/ql/ptree/pt_create_index.h"
+#include "yb/yql/cql/ql/ptree/pt_create_keyspace.h"
+#include "yb/yql/cql/ql/ptree/pt_create_role.h"
+#include "yb/yql/cql/ql/ptree/pt_create_table.h"
+#include "yb/yql/cql/ql/ptree/pt_create_type.h"
+#include "yb/yql/cql/ql/ptree/pt_delete.h"
+#include "yb/yql/cql/ql/ptree/pt_drop.h"
+#include "yb/yql/cql/ql/ptree/pt_explain.h"
+#include "yb/yql/cql/ql/ptree/pt_grant_revoke.h"
+#include "yb/yql/cql/ql/ptree/pt_select.h"
+#include "yb/yql/cql/ql/ptree/pt_truncate.h"
+#include "yb/yql/cql/ql/ptree/pt_use_keyspace.h"
+#include "yb/yql/cql/ql/util/statement_result.h"
+#include "yb/util/net/sockaddr.h"
+#include "yb/util/flag_tags.h"
+#include "yb/util/string_util.h"
+#include "yb/util/type_traits.h"
+
+DEFINE_bool(ycql_enable_audit_log,
+            false,
+            "Enable YCQL audit. Use ycql_audit_* flags for fine-grained configuration");
+TAG_FLAG(ycql_enable_audit_log, runtime);
+
+// IMPORTANT:
+// These flags are expected to change at runtime, but due to the nature of std::string we shouldn't
+// access them directly as a concurrent read-write access would lead to an undefined behaviour.
+// Instead, use FLAGS_NAMESPACE::GetCommandLineOption("flag_name", &result)
+
+DEFINE_string(ycql_audit_log_level,
+              "ERROR",
+              "Severity level at which an audit will be logged. Could be INFO, WARNING, or ERROR");
+TAG_FLAG(ycql_audit_log_level, runtime);
+
+DEFINE_string(ycql_audit_included_keyspaces,
+              "",
+              "Comma separated list of keyspaces to be included in the audit log, "
+              "if none - includes all keyspaces");
+TAG_FLAG(ycql_audit_included_keyspaces, runtime);
+
+DEFINE_string(ycql_audit_excluded_keyspaces,
+              "system,system_schema,system_virtual_schema,system_auth",
+              "Comma separated list of keyspaces to be excluded from the audit log");
+TAG_FLAG(ycql_audit_excluded_keyspaces, runtime);
+
+DEFINE_string(ycql_audit_included_categories,
+              "",
+              "Comma separated list of categories to be included in the audit log, "
+              "if none - includes all categories");
+TAG_FLAG(ycql_audit_included_categories, runtime);
+
+DEFINE_string(ycql_audit_excluded_categories,
+              "",
+              "Comma separated list of categories to be excluded from the audit log");
+TAG_FLAG(ycql_audit_excluded_categories, runtime);
+
+DEFINE_string(ycql_audit_included_users,
+              "",
+              "Comma separated list of users to be included in the audit log");
+TAG_FLAG(ycql_audit_included_users, runtime);
+
+DEFINE_string(ycql_audit_excluded_users,
+              "",
+              "Comma separated list of users to be excluded from the audit log");
+TAG_FLAG(ycql_audit_excluded_users, runtime);
+
+
+namespace yb {
+namespace ql {
+namespace audit {
+
+using boost::optional;
+using yb::cqlserver::CQLMessage;
+using yb::cqlserver::CQLResponse;
+using yb::cqlserver::ErrorResponse;
+
+//
+// Entities
+//
+
+namespace {
+
+// Audit categories are modelled after Apache Cassandra 4.0-beta2.
+YB_DEFINE_ENUM(Category, (QUERY)(DML)(DDL)(DCL)(AUTH)(PREPARE)(ERROR)(OTHER))
+
+} // anonymous namespace
+
+// Audit types are modelled after Apache Cassandra 4.0-beta2.
+#define YCQL_AUDIT_TYPES \
+    ((SELECT, QUERY)) \
+    ((UPDATE, DML)) /* Includes INSERT. */ \
+    ((DELETE, DML)) \
+    ((BATCH, DML)) \
+    \
+    /* DDL */ \
+    \
+    ((TRUNCATE, DDL)) \
+    ((CREATE_KEYSPACE, DDL)) \
+    ((ALTER_KEYSPACE, DDL)) \
+    ((DROP_KEYSPACE, DDL)) \
+    ((CREATE_TABLE, DDL)) \
+    ((DROP_TABLE, DDL)) \
+    ((CREATE_INDEX, DDL)) \
+    ((DROP_INDEX, DDL)) \
+    ((CREATE_TYPE, DDL)) \
+    ((ALTER_TABLE, DDL)) \
+    ((DROP_TYPE, DDL)) \
+    ((ALTER_TYPE, DDL)) \
+    \
+    /* DCL */ \
+    \
+    ((GRANT, DCL)) \
+    ((REVOKE, DCL)) \
+    ((CREATE_ROLE, DCL)) \
+    ((DROP_ROLE, DCL)) \
+    ((ALTER_ROLE, DCL)) \
+    \
+    /* AUTH */ \
+    \
+    ((LOGIN_ERROR, AUTH)) \
+    ((UNAUTHORIZED_ATTEMPT, AUTH)) \
+    ((LOGIN_SUCCESS, AUTH)) \
+    \
+    /* Misc */ \
+    \
+    ((PREPARE_STATEMENT, PREPARE)) \
+    ((REQUEST_FAILURE, ERROR)) \
+    ((USE_KEYSPACE, OTHER)) \
+    ((DESCRIBE, OTHER)) \
+    ((EXPLAIN, OTHER)) \
+    /**/
+
+#define DECLARE_YCQL_AUDIT_TYPE(type_name, category_name) \
+    static const Type type_name; \
+    /**/
+
+// Audit type with category, an enum-like class.
+class Type {
+ public:
+  BOOST_PP_SEQ_FOR_EACH(YB_STATUS_FORWARD_MACRO, DECLARE_YCQL_AUDIT_TYPE, YCQL_AUDIT_TYPES)
+
+  const std::string name_;
+  const Category    category_;
+
+ private:
+  explicit Type(std::string name, Category category)
+      : name_(std::move(name)), category_(category) {
+  }
+};
+
+#define DEFINE_YCQL_AUDIT_TYPE(type_name, category_name) \
+    const Type Type::type_name = Type(BOOST_PP_STRINGIZE(type_name), Category::category_name); \
+    /**/
+
+BOOST_PP_SEQ_FOR_EACH(YB_STATUS_FORWARD_MACRO, DEFINE_YCQL_AUDIT_TYPE, YCQL_AUDIT_TYPES)
+
+struct LogEntry {
+  // Username of the currently active user, special case is "anonymous" user. None if not logged in.
+  // Note that we can't distinguish between anonymous user and user named "anonymous",
+  // but that's expected.
+  optional<std::string> user;
+
+  // Host (current node) endpoint.
+  const Endpoint& host;
+
+  // Source (CQL client) endpoint.
+  const Endpoint& source;
+
+  // Node local timestamp, unrelated to transaction read point.
+  const Timestamp timestamp;
+
+  // Audit log entry type (and category). Cannot be null.
+  const Type* type;
+
+  // Batch ID, for driver-level batch requests only.
+  const std::string batch_id;
+
+  // Keyspace, if applicable, empty string if none.
+  const std::string keyspace;
+
+  // Scope, if applicable, empty string if none. Exact meaning of "scope" depends on an operation.
+  const std::string scope;
+
+  // CQL being executed, or login status.
+  std::string operation;
+
+  // Operaion error message, empty string if none.
+  std::string error_message;
+
+  std::string ToString() const {
+    return Format("{ user: $0, host: $1, source: $2, timestamp: $3, type: $4, category: $5,"
+                  " keyspace: $6, scope: $7, operation: $8, error_message: $9 }",
+                  user, host, source, timestamp, type->name_, type->category_,
+                  keyspace, scope, operation, error_message);
+  }
+};
+
+
+//
+// Local functions
+//
+
+namespace {
+
+// * Splits a comma-separated gflag list
+// * Trims each string
+// * Uppercases them (using the fact that CQL's keyspaces and users are case-insensitive)
+// * Filters out empty strings
+std::unordered_set<std::string> SplitGflagList(const std::string& gflag) {
+  std::vector<std::string> split;
+  boost::split(split, gflag, boost::is_any_of(","), boost::token_compress_on);
+  for (auto& s : split) {
+    boost::algorithm::trim(s);
+    boost::algorithm::to_upper(s);
+  }
+  split.erase(std::remove_if(split.begin(), split.end(), [](auto& s){ return s.empty(); }),
+              split.end());
+  return std::unordered_set<std::string>(split.begin(), split.end());
+}
+
+template<typename T>
+bool Contains(const std::unordered_set<T>& set, const T& value) {
+  return set.find(value) != set.end();
+}
+
+// Return an audit log type for a tree node, or nullptr if a node can't be audited.
+// Also sets an operation keyspace and scope, if applicable, following Cassandra's behaviour.
+const Type* GetAuditLogTypeOption(const TreeNode& tnode,
+                                  std::string* keyspace,
+                                  std::string* scope) {
+  // FIXME: DESCRIBE and LIST <...> are client-only operations and are not audited!
+  switch (tnode.opcode()) {
+    case TreeNodeOpcode::kPTSelectStmt: {
+      const auto& cast_node = static_cast<const PTSelectStmt&>(tnode);
+      *keyspace = cast_node.table_name().namespace_name();
+      *scope    = cast_node.table_name().table_name();
+      return &Type::SELECT;
+    }
+    case TreeNodeOpcode::kPTInsertStmt:
+    case TreeNodeOpcode::kPTUpdateStmt: {
+      const auto& cast_node = static_cast<const PTDmlStmt&>(tnode);
+      *keyspace = cast_node.table_name().namespace_name();
+      *scope    = cast_node.table_name().table_name();
+      return &Type::UPDATE;
+    }
+    case TreeNodeOpcode::kPTDeleteStmt: {
+      const auto& cast_node = static_cast<const PTDeleteStmt&>(tnode);
+      *keyspace = cast_node.table_name().namespace_name();
+      *scope    = cast_node.table_name().table_name();
+      return &Type::DELETE;
+    }
+    case TreeNodeOpcode::kPTTruncateStmt: {
+      const auto& cast_node = static_cast<const PTTruncateStmt&>(tnode);
+      *keyspace = cast_node.yb_table_name().namespace_name();
+      *scope    = cast_node.yb_table_name().table_name();
+      return &Type::TRUNCATE;
+    }
+    case TreeNodeOpcode::kPTCreateKeyspace: {
+      const auto& cast_node = static_cast<const PTCreateKeyspace&>(tnode);
+      *keyspace = cast_node.name();
+      return &Type::CREATE_KEYSPACE;
+    }
+    case TreeNodeOpcode::kPTAlterKeyspace: {
+      const auto& cast_node = static_cast<const PTAlterKeyspace&>(tnode);
+      *keyspace = cast_node.name();
+      return &Type::ALTER_KEYSPACE;
+    }
+    case TreeNodeOpcode::kPTUseKeyspace: {
+      const auto& cast_node = static_cast<const PTUseKeyspace&>(tnode);
+      *keyspace = cast_node.name();
+      return &Type::USE_KEYSPACE;
+    }
+    case TreeNodeOpcode::kPTDropStmt: {
+      const auto& cast_node = static_cast<const PTDropStmt&>(tnode);
+      // We only expect a handful of types here, same as Executor::ExecPTNode(const PTDropStmt*)
+      switch (cast_node.drop_type()) {
+        case OBJECT_SCHEMA:
+          *keyspace = cast_node.name()->last_name().data();
+          return &Type::DROP_KEYSPACE;
+        case OBJECT_INDEX:
+          *keyspace = cast_node.yb_table_name().namespace_name();
+          *scope    = cast_node.yb_table_name().table_name();
+          return &Type::DROP_INDEX;
+        case OBJECT_ROLE:
+          return &Type::DROP_ROLE;
+        case OBJECT_TABLE:
+          *keyspace = cast_node.yb_table_name().namespace_name();
+          *scope    = cast_node.yb_table_name().table_name();
+          return &Type::DROP_TABLE;
+        case OBJECT_TYPE:
+          *keyspace = cast_node.name()->first_name().data();
+          *scope    = cast_node.name()->last_name().data();
+          return &Type::DROP_TYPE;
+        default:
+          return nullptr;
+      }
+    }
+    case TreeNodeOpcode::kPTCreateTable: {
+      const auto& cast_node = static_cast<const PTCreateTable&>(tnode);
+      *keyspace = cast_node.yb_table_name().namespace_name();
+      *scope    = cast_node.yb_table_name().table_name();
+      return &Type::CREATE_TABLE;
+    }
+    case TreeNodeOpcode::kPTCreateIndex: {
+      const auto& cast_node = static_cast<const PTCreateIndex&>(tnode);
+      *keyspace = cast_node.yb_table_name().namespace_name();
+      *scope    = cast_node.yb_table_name().table_name();
+      return &Type::CREATE_INDEX;
+    }
+    case TreeNodeOpcode::kPTAlterTable: {
+      const auto& cast_node = static_cast<const PTAlterTable&>(tnode);
+      *keyspace = cast_node.yb_table_name().namespace_name();
+      *scope    = cast_node.yb_table_name().table_name();
+      return &Type::ALTER_TABLE;
+    }
+    case TreeNodeOpcode::kPTCreateRole: {
+      // Scope is not used.
+      return &Type::CREATE_ROLE;
+    }
+    case TreeNodeOpcode::kPTAlterRole: {
+      // Scope is not used.
+      return &Type::ALTER_ROLE;
+    }
+    case TreeNodeOpcode::kPTCreateType: {
+      const auto& cast_node = static_cast<const PTCreateType&>(tnode);
+      *keyspace = cast_node.yb_type_name().namespace_name();
+      *scope    = cast_node.yb_type_name().table_name();
+      return &Type::CREATE_TYPE;
+    }
+    case TreeNodeOpcode::kPTGrantRevokePermission: {
+      const auto& cast_node = static_cast<const PTGrantRevokePermission&>(tnode);
+      // Scope hierarchy for GRANT/REVOKE is a bit unusual, see DataResource and RoleResource
+      // classes in Cassandra.
+      switch (cast_node.resource_type()) {
+        case ALL_KEYSPACES:
+          *keyspace = "data";
+          *scope    = "data";
+          break;
+        case KEYSPACE:
+          *keyspace = "data";
+          *scope    = Format("data/$0", cast_node.namespace_name());
+          break;
+        case TABLE:
+          *keyspace = Format("data/$0",    cast_node.namespace_name());
+          *scope    = Format("data/$0/$1", cast_node.namespace_name(), cast_node.resource_name());
+          break;
+        case ALL_ROLES:
+          *keyspace = "roles";
+          *scope    = "roles";
+          break;
+        case ROLE:
+          *keyspace = "roles";
+          *scope    = Format("roles/$0", cast_node.resource_name());
+          break;
+      }
+      switch (cast_node.statement_type()) {
+        case GrantRevokeStatementType::GRANT:
+          return &Type::GRANT;
+        case GrantRevokeStatementType::REVOKE:
+          return &Type::REVOKE;
+      }
+      FATAL_INVALID_ENUM_VALUE(GrantRevokeStatementType, cast_node.statement_type());
+    }
+    case TreeNodeOpcode::kPTGrantRevokeRole: {
+      const auto& cast_node = static_cast<const PTGrantRevokeRole&>(tnode);
+      // Scope is not used.
+      switch (cast_node.statement_type()) {
+        case GrantRevokeStatementType::GRANT:
+          return &Type::GRANT;
+        case GrantRevokeStatementType::REVOKE:
+          return &Type::REVOKE;
+      }
+      FATAL_INVALID_ENUM_VALUE(GrantRevokeStatementType, cast_node.statement_type());
+    }
+
+    case TreeNodeOpcode::kPTListNode: {
+      // As per YCQL grammar, list node can only be a DML batch.
+      // Everything from PTStartTransaction to PTCommit (inclusive) is packed to PTListNode.
+      return &Type::BATCH;
+    }
+
+    case TreeNodeOpcode::kPTStartTransaction: {
+      // This will usually be inside PTListNode, but we can explicitly issue START TRANSACTION
+      // from YCQL driver.
+      return &Type::BATCH;
+    }
+
+    case TreeNodeOpcode::kPTCommit: {
+      // This will usually be inside PTListNode, but we can explicitly issue COMMIT
+      // from YCQL driver.
+      // Also, standalone COMMIT is permitted even from ysqlsh (does nothing).
+      return &Type::BATCH;
+    }
+
+    case TreeNodeOpcode::kPTExplainStmt: {
+      const auto& cast_node = static_cast<const PTExplainStmt&>(tnode);
+      const auto& sub_stmt  = static_cast<const PTDmlStmt&>(*cast_node.stmt());
+      *keyspace = sub_stmt.table_name().namespace_name();
+      *scope    = sub_stmt.table_name().table_name();
+      return &Type::EXPLAIN;
+    }
+
+    case TreeNodeOpcode::kPTName:
+    case TreeNodeOpcode::kPTProperty:
+    case TreeNodeOpcode::kPTStatic:
+    case TreeNodeOpcode::kPTConstraint:
+    case TreeNodeOpcode::kPTCollection:
+    case TreeNodeOpcode::kPTPrimitiveType:
+    case TreeNodeOpcode::kPTColumnDefinition:
+    case TreeNodeOpcode::kPTAlterColumnDefinition:
+    case TreeNodeOpcode::kPTDmlUsingClauseElement:
+    case TreeNodeOpcode::kPTTableRef:
+    case TreeNodeOpcode::kPTOrderBy:
+    case TreeNodeOpcode::kPTRoleOption:
+    case TreeNodeOpcode::kPTInsertValuesClause:
+    case TreeNodeOpcode::kPTInsertJsonClause:
+    case TreeNodeOpcode::kPTExpr:
+    case TreeNodeOpcode::kPTRef:
+    case TreeNodeOpcode::kPTSubscript:
+    case TreeNodeOpcode::kPTAllColumns:
+    case TreeNodeOpcode::kPTAssign:
+    case TreeNodeOpcode::kPTBindVar:
+    case TreeNodeOpcode::kPTJsonOp:
+    case TreeNodeOpcode::kPTTypeField:
+    case TreeNodeOpcode::kNoOp:
+      return nullptr;
+
+  }
+  FATAL_INVALID_ENUM_VALUE(TreeNodeOpcode, tnode.opcode());
+}
+
+// Replace sensitive information in a CQL command string with <REDACTED> placeholders.
+// We only do this for CREATE/ALTER ROLE.
+std::string ObfuscateOperation(const TreeNode& tnode, const std::string& operation) {
+  if (tnode.opcode() != TreeNodeOpcode::kPTCreateRole &&
+      tnode.opcode() != TreeNodeOpcode::kPTAlterRole) {
+    return operation;
+  }
+
+  static const auto replacement = "<REDACTED>";
+  // Using somewhat tricky code to account for escaped quotes ('') in a password.
+  // We replace an entire string, including quotes.
+  static const std::regex pwd_start_regex("password[\\s]*=[\\s]*'");
+  std::smatch m;
+  if (!regex_search(operation, m, pwd_start_regex)) {
+    return operation;
+  }
+  int pwd_start_idx = m.position() + m.length() - 1;
+  int pwd_length = -1;
+  for (int i = pwd_start_idx + 1; i < operation.length(); ++i) {
+    if (operation[i] == '\'') {
+      // If the next character is a quote too - this is an escaped quote.
+      if (i < operation.length() - 1 && operation[i + 1] == '\'') {
+        ++i; // Skip both quotes.
+      } else {
+        pwd_length = i - pwd_start_idx + 1;
+        break;
+      }
+    }
+  }
+  if (pwd_length == -1) {
+    return operation;
+  }
+  std::string copy(operation);
+  copy.replace(pwd_start_idx, pwd_length, replacement);
+  return copy;
+}
+
+// Follows Cassandra's view format for prettified binary log.
+CHECKED_STATUS AddLogEntry(const LogEntry& e) {
+  std::string str;
+  str.reserve(512); // Some reasonable default that's expected to fit most of the audit records.
+  str.append("AUDIT: ");
+  str.append("user:");
+  str.append(e.user ? *e.user : "null");
+  str.append("|host:");
+  str.append(AsString(e.host));
+  str.append("|source:");
+  str.append(AsString(e.source.address()));
+  str.append("|port:");
+  str.append(AsString(e.source.port()));
+  str.append("|timestamp:");
+  str.append(std::to_string(e.timestamp.ToInt64() / 1000));
+  str.append("|type:");
+  str.append(e.type->name_);
+  str.append("|category:");
+  str.append(AsString(e.type->category_));
+  if (!e.batch_id.empty()) {
+    str.append("|batch:");
+    str.append(e.batch_id);
+  }
+  if (!e.keyspace.empty()) {
+    str.append("|ks:");
+    str.append(e.keyspace);
+  }
+  if (!e.scope.empty()) {
+    str.append("|scope:");
+    str.append(e.scope);
+  }
+  str.append("|operation:");
+  str.append(e.operation);
+  if (!e.error_message.empty()) {
+    str.append("; ");
+    str.append(e.error_message);
+  }
+  // Since glog uses macros, it's not too convenient to extract a log level.
+  auto severity = boost::algorithm::to_lower_copy(FLAGS_ycql_audit_log_level);
+  if (severity == "info") {
+    LOG(INFO) << str;
+    return Status::OK();
+  } else if (severity == "warning") {
+    LOG(WARNING) << str;
+    return Status::OK();
+  } else if (severity == "error") {
+    LOG(ERROR) << str;
+    return Status::OK();
+  } else {
+    return STATUS_FORMAT(InvalidArgument,
+                         "$0 is not a valid severity level",
+                         FLAGS_ycql_audit_log_level);
+  }
+}
+
+} // anonymous namespace
+
+//
+// AuditLogger class definitions
+//
+
+AuditLogger::AuditLogger(const QLEnv& ql_env) : ql_env_(ql_env) {
+}
+
+template<class Pred>
+bool AuditLogger::SatisfiesGFlag(const LogEntry& e,
+                                 const std::string& gflag_name,
+                                 const Pred& predicate) {
+  std::string gflag_value;
+  bool found = GFLAGS_NAMESPACE::GetCommandLineOption(gflag_name.c_str(), &gflag_value);
+  if (!found) {
+    // This should never happen as we use compile-time check in a macro.
+    LOG(FATAL) << "Gflag " << gflag_name << " does not exist!";
+    return false;
+  }
+
+  auto& cached = gflags_cache_[gflag_name];
+  if (cached.first != gflag_value) {
+    VLOG(2) << "Audit flag " << gflag_name << " = " << gflag_value
+            << " cache was invalid, old value = " << cached.first;
+    cached.first  = gflag_value;
+    cached.second = SplitGflagList(gflag_value);
+  }
+  const auto& split = cached.second;
+
+  if (!split.empty() && !predicate(split, e)) {
+    VLOG(1) << "Filtered out audit record: " << e.ToString()
+            << ", flag: " << gflag_name << " = " << gflag_value;
+    return false;
+  }
+  return true;
+}
+
+// Helper macro to avoid boilerplate when using SatisfiesGFlag function.
+// Returns false if the given predicate is not satisfied.
+#define RETURN_IF_NOT_SATISFIES_GFLAG(gflag, entry, predicate_on_split_and_e) \
+    static_assert(std::is_same<decltype(BOOST_PP_CAT(FLAGS_, gflag)), std::string&>::value, \
+                  "Flag must be string"); \
+    \
+    if (!SatisfiesGFlag(e, BOOST_PP_STRINGIZE(gflag), \
+                        [](const GflagListValue& split, const LogEntry& e) { \
+                          return predicate_on_split_and_e; \
+                        })) { \
+      return false; \
+    } \
+    /**/
+
+bool AuditLogger::ShouldBeLogged(const LogEntry& e) {
+  // If a keyspace isn't present, it's not used for filtering.
+  if (!e.keyspace.empty()) {
+    RETURN_IF_NOT_SATISFIES_GFLAG(
+        ycql_audit_included_keyspaces, e,
+        Contains(split, boost::algorithm::to_upper_copy(e.keyspace)))
+    RETURN_IF_NOT_SATISFIES_GFLAG(
+        ycql_audit_excluded_keyspaces, e,
+        !Contains(split, boost::algorithm::to_upper_copy(e.keyspace)))
+  }
+
+  RETURN_IF_NOT_SATISFIES_GFLAG(
+      ycql_audit_included_categories, e,
+      Contains(split, AsString(e.type->category_)))
+  RETURN_IF_NOT_SATISFIES_GFLAG(
+      ycql_audit_excluded_categories, e,
+      !Contains(split, AsString(e.type->category_)))
+
+  // Include filter always removes userless entries.
+  RETURN_IF_NOT_SATISFIES_GFLAG(
+      ycql_audit_included_users, e,
+      e.user && Contains(split, boost::algorithm::to_upper_copy(*e.user)))
+  RETURN_IF_NOT_SATISFIES_GFLAG(
+      ycql_audit_excluded_users, e,
+      !e.user || !Contains(split, boost::algorithm::to_upper_copy(*e.user)))
+
+  return true;
+}
+
+Result<LogEntry> AuditLogger::CreateLogEntry(const Type& type,
+                                             std::string keyspace,
+                                             std::string scope,
+                                             std::string operation,
+                                             std::string error_message) {
+  SCHECK(conn_ != nullptr, InternalError, "Connection is not initialized");
+  auto curr_user = ql_env_.CurrentRoleName();
+  if (curr_user.empty()) {
+    curr_user = "anonymous";
+  }
+  auto entry = LogEntry {
+    .user          = std::move(curr_user),
+    .host          = conn_->local(),
+    .source        = conn_->remote(),
+    .timestamp     = DateTime::TimestampNow(),
+    .type          = &type,
+    .batch_id      = batch_id_,
+    .keyspace      = std::move(keyspace),
+    .scope         = std::move(scope),
+    .operation     = std::move(operation),
+    .error_message = std::move(error_message)
+  };
+  return std::move(entry);
+}
+
+Status AuditLogger::StartBatchRequest(int statements_count) {
+  if (!FLAGS_ycql_enable_audit_log) {
+    return Status::OK();
+  }
+
+  if (rescheduled_ && !batch_id_.empty()) {
+    // Keep an existing batch ID in case of reschedule.
+    return Status::OK();
+  }
+
+  // We cannot have sub-batches as only DMLs are allowed within a batch.
+  SCHECK(batch_id_.empty(), InternalError, "Batch request mode is already active!");
+
+  batch_id_ = AsString(boost::uuids::random_generator()());
+
+  auto operation = Format("BatchId:[$0] - BATCH of [$1] statements", batch_id_, statements_count);
+
+  // Cassandra uses the currently active keyspace here, for whatever reason.
+  // We don't as it's cumbersome to track.
+  auto entry_result = CreateLogEntry(Type::BATCH,
+                                     "" /* keyspace */,
+                                     "" /* scope */,
+                                     std::move(operation),
+                                     "" /* error_message */);
+  if (PREDICT_FALSE(!entry_result.ok())) {
+    batch_id_ = "";
+    return entry_result.status();
+  }
+
+  if (!ShouldBeLogged(*entry_result)) {
+    return Status::OK();
+  }
+
+  auto s = AddLogEntry(*entry_result);
+  if (PREDICT_FALSE(!s.ok())) {
+    batch_id_ = "";
+  }
+  return s;
+}
+
+Status AuditLogger::EndBatchRequest() {
+  batch_id_ = "";
+  return Status::OK();
+}
+
+Status AuditLogger::LogAuthResponse(const CQLResponse& response) {
+  if (!FLAGS_ycql_enable_audit_log) {
+    return Status::OK();
+  }
+
+  // Initialize entry assuming the happy case
+  auto entry = VERIFY_RESULT(CreateLogEntry(Type::LOGIN_SUCCESS,
+                                            "" /* keyspace */,
+                                            "" /* scope */,
+                                            "LOGIN SUCCESSFUL",
+                                            "" /* error_message */));
+  switch (response.opcode()) {
+    case CQLMessage::Opcode::AUTH_SUCCESS:
+      break;
+    case CQLMessage::Opcode::ERROR: {
+      const auto& error_respone = static_cast<const ErrorResponse&>(response);
+      entry.user          = boost::none;
+      entry.type          = &Type::LOGIN_ERROR;
+      entry.operation     = "LOGIN FAILURE";
+      entry.error_message = error_respone.message();
+      break;
+    }
+    default:
+      return STATUS_FORMAT(InternalError,
+                           "$0 is not a valid opcode for an auth response",
+                           static_cast<uint8_t>(response.opcode()));
+  }
+
+  if (!ShouldBeLogged(entry)) {
+    return Status::OK();
+  }
+
+  return AddLogEntry(entry);
+}
+
+Status AuditLogger::LogStatement(const TreeNode* tnode,
+                                 const std::string& statement,
+                                 bool is_prepare) {
+  // FIXME(alex): Rescheduled statements should not be logged.
+  if (!FLAGS_ycql_enable_audit_log || !tnode /* || rescheduled_*/) {
+    return Status::OK();
+  }
+
+  std::string keyspace;
+  std::string scope;
+  auto type_option = GetAuditLogTypeOption(*tnode, &keyspace, &scope);
+  if (!type_option)
+    return Status::OK();
+
+  auto entry = VERIFY_RESULT(CreateLogEntry(*type_option,
+                                            std::move(keyspace),
+                                            std::move(scope),
+                                            ObfuscateOperation(*tnode, statement),
+                                            "" /* error_message */));
+  if (is_prepare) {
+    entry.type = &Type::PREPARE_STATEMENT;
+  }
+
+  if (!ShouldBeLogged(entry)) {
+    return Status::OK();
+  }
+
+  return AddLogEntry(entry);
+}
+
+Status AuditLogger::LogStatementError(const TreeNode* tnode,
+                                      const std::string& statement,
+                                      const Status& error_status,
+                                      bool error_is_formatted) {
+  if (!FLAGS_ycql_enable_audit_log || !tnode) {
+    return Status::OK();
+  }
+
+  return LogStatementError(ObfuscateOperation(*tnode, statement), error_status, error_is_formatted);
+}
+
+Status AuditLogger::LogStatementError(const std::string& statement,
+                                      const Status& error_status,
+                                      bool error_is_formatted) {
+  if (!FLAGS_ycql_enable_audit_log) {
+    return Status::OK();
+  }
+
+  SCHECK(!error_status.ok(), InvalidArgument, "Operation hasn't failed");
+
+  const Type& type = GetErrorCode(error_status) == ErrorCode::UNAUTHORIZED
+                        ? Type::UNAUTHORIZED_ATTEMPT
+                        : Type::REQUEST_FAILURE;
+  std::string error_message = error_status.ToUserMessage();
+  if (error_is_formatted) {
+    // We've already concatenated message with CQL error location.
+    // Here we use dirty hack, removing three trailing lines to get rid of it.
+    auto split = StringSplit(error_message, '\n');
+    SCHECK(split.size() > 3, InvalidArgument, "Unexpected error message format");
+    split.resize(split.size() - 3);
+    error_message = boost::algorithm::join(split, "\n");
+  }
+
+  // For failed requests, we do not log keyspace and scope even if we have them.
+  auto entry = VERIFY_RESULT(CreateLogEntry(type,
+                                            "" /* keyspace */,
+                                            "" /* scope */,
+                                            statement,
+                                            std::move(error_message)));
+
+  if (!ShouldBeLogged(entry)) {
+    return Status::OK();
+  }
+
+  return AddLogEntry(entry);
+}
+
+} // namespace audit
+} // namespace ql
+} // namespace yb
diff --git a/src/yb/yql/cql/ql/audit/audit_logger.h b/src/yb/yql/cql/ql/audit/audit_logger.h
new file mode 100644
index 000000000000..f8fa960156c4
--- /dev/null
+++ b/src/yb/yql/cql/ql/audit/audit_logger.h
@@ -0,0 +1,128 @@
+//--------------------------------------------------------------------------------------------------
+// Copyright (c) YugaByte, Inc.
+//
+// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
+// in compliance with the License.  You may obtain a copy of the License at
+//
+// http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software distributed under the License
+// is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
+// or implied.  See the License for the specific language governing permissions and limitations
+// under the License.
+//
+//
+// Responsible for logging audit records in YCQL.
+// Audit is controlled through gflags. If the audit is not enabled, logging methods return
+// immediately without imposing overhead.
+//--------------------------------------------------------------------------------------------------
+
+#ifndef YB_YQL_CQL_QL_AUDIT_AUDIT_LOGGER_H_
+#define YB_YQL_CQL_QL_AUDIT_AUDIT_LOGGER_H_
+
+#include "yb/common/common.pb.h"
+#include "yb/yql/cql/cqlserver/cql_message.h"
+#include "yb/yql/cql/ql/exec/exec_context.h"
+
+namespace yb {
+namespace ql {
+namespace audit {
+
+class Type;
+struct LogEntry;
+
+class AuditLogger {
+ public:
+  explicit AuditLogger(const QLEnv& ql_env);
+
+  // Sets a connection for the current (new) user operation, resetting the rescheduled mark.
+  void SetConnection(const std::shared_ptr<const rpc::Connection>& conn) {
+    conn_ = conn;
+    rescheduled_ = false;
+  }
+
+  // Marks a current execution as being rescheduled. This will suppress non-erroneous statement
+  // execution logging, and is reset by SetConnection().
+  void MarkRescheduled() {
+    rescheduled_ = true;
+  }
+
+  // Enters the batch request mode, should be called when driver-level batch is received.
+  // This generates a UUID to identify the current batch in audit.
+  //
+  // Note that this is only used for batch requests, not for explicit START TRANSACTION commands
+  // because in that case separate commands might arrive to different tservers.
+  //
+  // If this returns non-OK status, batch mode isn't activated.
+  CHECKED_STATUS StartBatchRequest(int statements_count);
+
+  // Exits the batch request mode. Does nothing outside of a batch request.
+  CHECKED_STATUS EndBatchRequest();
+
+  // Log the response to a user's authentication request.
+  CHECKED_STATUS LogAuthResponse(const cqlserver::CQLResponse& response);
+
+  // Log the statement execution start.
+  // tnode might be nullptr, in which case this does nothing.
+  CHECKED_STATUS LogStatement(const TreeNode* tnode,
+                              const std::string& statement,
+                              bool is_prepare);
+
+  // Log the statement analysis/execution failure.
+  // tnode might be nullptr, in which case this does nothing.
+  CHECKED_STATUS LogStatementError(const TreeNode* tnode,
+                                   const std::string& statement,
+                                   const Status& error_status,
+                                   bool error_is_formatted);
+
+  // Log a general statement processing failure.
+  // We should only use this directly when the parse tree is not present.
+  CHECKED_STATUS LogStatementError(const std::string& statement,
+                                   const Status& error_status,
+                                   bool error_is_formatted);
+
+ private:
+  using GflagName = std::string;
+  using GflagStringValue = std::string;
+  using GflagListValue = std::unordered_set<std::string>;
+  using GflagsCache = std::unordered_map<GflagName, std::pair<GflagStringValue, GflagListValue>>;
+
+  // Whether the execution is being retried.
+  bool rescheduled_ = false;
+
+  const QLEnv& ql_env_;
+
+  // Currently audited connection.
+  std::shared_ptr<const rpc::Connection> conn_;
+
+  // Empty string means not in a batch processing mode.
+  std::string batch_id_;
+
+  // Cache of parsed gflags, to avoid re-parsing unchanged values.
+  GflagsCache gflags_cache_;
+
+  // Checks whether a given predicate holds on the comma-separated list gflag.
+  // This uses gflag library helper to access a gflag by name, to avoid concurrently accessing
+  // string gflags that may change at runtime.
+  template<class Pred>
+  bool SatisfiesGFlag(const LogEntry& e,
+                      const std::string& gflag_name,
+                      const Pred& predicate);
+
+  // Determine whether this entry should be logged given current audit configuration.
+  // Note that we reevaluate gflags to allow changing them dynamically.
+  bool ShouldBeLogged(const LogEntry& e);
+
+  Result<LogEntry> CreateLogEntry(const Type& type,
+                                  std::string keyspace,
+                                  std::string scope,
+                                  std::string operation,
+                                  std::string error_message);
+};
+
+} // namespace audit
+} // namespace ql
+} // namespace yb
+
+
+#endif // YB_YQL_CQL_QL_AUDIT_AUDIT_LOGGER_H_
diff --git a/src/yb/yql/cql/ql/exec/CMakeLists.txt b/src/yb/yql/cql/ql/exec/CMakeLists.txt
index 4dcf2c1f8788..e7b41c94c55f 100644
--- a/src/yb/yql/cql/ql/exec/CMakeLists.txt
+++ b/src/yb/yql/cql/ql/exec/CMakeLists.txt
@@ -27,6 +27,7 @@ add_library(ql_exec
 
 target_link_libraries(ql_exec
                       ql_parser
+                      ql_audit
                       yb_client
                       yb_util)
-add_dependencies(ql_exec ql_parser)
+add_dependencies(ql_exec ql_parser ql_audit)
diff --git a/src/yb/yql/cql/ql/exec/executor.cc b/src/yb/yql/cql/ql/exec/executor.cc
index 4ca9c25baf8f..77e27dd328da 100644
--- a/src/yb/yql/cql/ql/exec/executor.cc
+++ b/src/yb/yql/cql/ql/exec/executor.cc
@@ -45,6 +45,7 @@ using std::string;
 using std::shared_ptr;
 using namespace std::placeholders;
 
+using audit::AuditLogger;
 using client::YBColumnSpec;
 using client::YBOperation;
 using client::YBqlOpPtr;
@@ -68,8 +69,10 @@ using strings::Substitute;
 
 //--------------------------------------------------------------------------------------------------
 
-Executor::Executor(QLEnv *ql_env, Rescheduler* rescheduler, const QLMetrics* ql_metrics)
+Executor::Executor(QLEnv* ql_env, AuditLogger* audit_logger, Rescheduler* rescheduler,
+                   const QLMetrics* ql_metrics)
     : ql_env_(ql_env),
+      audit_logger_(*audit_logger),
       rescheduler_(rescheduler),
       session_(ql_env_->NewSession()),
       ql_metrics_(ql_metrics) {
@@ -166,6 +169,8 @@ void Executor::ExecuteAsync(const StatementBatch& batch, StatementExecutedCallba
     RETURN_STMT_NOT_OK(Execute(parse_tree, params));
   }
 
+  RETURN_STMT_NOT_OK(audit_logger_.EndBatchRequest());
+
   FlushAsync();
 }
 
@@ -177,7 +182,14 @@ Status Executor::Execute(const ParseTree& parse_tree, const StatementParameters&
   exec_context_ = &exec_contexts_.back();
   auto root_node = parse_tree.root().get();
   RETURN_NOT_OK(PreExecTreeNode(root_node));
-  return ProcessStatementStatus(parse_tree, ExecTreeNode(root_node));
+  RETURN_NOT_OK(audit_logger_.LogStatement(root_node, exec_context_->stmt(),
+                                           false /* is_prepare */));
+  Status s = ExecTreeNode(root_node);
+  if (!s.ok()) {
+    RETURN_NOT_OK(audit_logger_.LogStatementError(root_node, exec_context_->stmt(), s,
+                                                  false /* error_is_formatted */));
+  }
+  return ProcessStatementStatus(parse_tree, s);
 }
 
 //--------------------------------------------------------------------------------------------------
diff --git a/src/yb/yql/cql/ql/exec/executor.h b/src/yb/yql/cql/ql/exec/executor.h
index 0001e3faf38b..d1de905fae60 100644
--- a/src/yb/yql/cql/ql/exec/executor.h
+++ b/src/yb/yql/cql/ql/exec/executor.h
@@ -23,6 +23,7 @@
 #include "yb/common/ql_rowblock.h"
 #include "yb/common/common.pb.h"
 #include "yb/rpc/thread_pool.h"
+#include "yb/yql/cql/ql/audit/audit_logger.h"
 #include "yb/yql/cql/ql/exec/exec_context.h"
 #include "yb/yql/cql/ql/ptree/pt_create_keyspace.h"
 #include "yb/yql/cql/ql/ptree/pt_use_keyspace.h"
@@ -68,7 +69,8 @@ class Executor : public QLExprExecutor {
 
   //------------------------------------------------------------------------------------------------
   // Constructor & destructor.
-  Executor(QLEnv *ql_env, Rescheduler* rescheduler, const QLMetrics* ql_metrics);
+  Executor(QLEnv *ql_env, audit::AuditLogger* audit_logger, Rescheduler* rescheduler,
+           const QLMetrics* ql_metrics);
   virtual ~Executor();
 
   // Execute the given statement (parse tree) or batch. The parse trees and the parameters must not
@@ -408,6 +410,9 @@ class Executor : public QLExprExecutor {
   // Environment (YBClient) for executing statements.
   QLEnv *ql_env_;
 
+  // Used for logging audit records.
+  audit::AuditLogger& audit_logger_;
+
   // A rescheduler to reschedule the current call.
   Rescheduler* const rescheduler_;
 
diff --git a/src/yb/yql/cql/ql/ptree/list_node.h b/src/yb/yql/cql/ql/ptree/list_node.h
index adf297e5cda5..14715c30436e 100644
--- a/src/yb/yql/cql/ql/ptree/list_node.h
+++ b/src/yb/yql/cql/ql/ptree/list_node.h
@@ -15,6 +15,9 @@
 // List Node Declaration.
 //
 // This modules includes specifications for nodes that contain a list of tree nodes.
+//
+// YCQL audit expects these nodes to be DMLs encased between PTStartTransaction and PTCommit,
+// which is verified during Analyze step.
 //--------------------------------------------------------------------------------------------------
 
 #ifndef YB_YQL_CQL_QL_PTREE_LIST_NODE_H_
diff --git a/src/yb/yql/cql/ql/ql_processor.cc b/src/yb/yql/cql/ql/ql_processor.cc
index f75ecbc1d057..ca024ea60238 100644
--- a/src/yb/yql/cql/ql/ql_processor.cc
+++ b/src/yb/yql/cql/ql/ql_processor.cc
@@ -138,8 +138,9 @@ QLProcessor::QLProcessor(client::YBClient* client,
                          const server::ClockPtr& clock,
                          TransactionPoolProvider transaction_pool_provider)
     : ql_env_(client, cache, clock, std::move(transaction_pool_provider)),
+      audit_logger_(ql_env_),
       analyzer_(&ql_env_),
-      executor_(&ql_env_, this, ql_metrics),
+      executor_(&ql_env_, &audit_logger_, this, ql_metrics),
       ql_metrics_(ql_metrics),
       parser_pool_(parser_pool ? parser_pool : &default_parser_pool) {
 }
@@ -156,12 +157,16 @@ Status QLProcessor::Parse(const string& stmt, ParseTree::UniPtr* parse_tree,
   auto scope_exit = ScopeExit([this, parser] {
     this->parser_pool_->Release(parser);
   });
-  RETURN_NOT_OK(parser->Parse(stmt, reparsed, mem_tracker, internal));
+  const Status s = parser->Parse(stmt, reparsed, mem_tracker, internal);
   const MonoTime end_time = MonoTime::Now();
   if (ql_metrics_ != nullptr) {
     const MonoDelta elapsed_time = end_time.GetDeltaSince(begin_time);
     ql_metrics_->time_to_parse_ql_query_->Increment(elapsed_time.ToMicroseconds());
   }
+  if (!s.ok()) {
+    RETURN_NOT_OK(audit_logger_.LogStatementError(stmt, s, true /* error_is_formatted */));
+    return s;
+  }
   *parse_tree = parser->Done();
   DCHECK(*parse_tree) << "Parse tree is null";
   return Status::OK();
@@ -186,11 +191,15 @@ Status QLProcessor::Prepare(const string& stmt, ParseTree::UniPtr* parse_tree,
                             const bool reparsed, const MemTrackerPtr& mem_tracker,
                             const bool internal) {
   RETURN_NOT_OK(Parse(stmt, parse_tree, reparsed, mem_tracker, internal));
-  const Status s = Analyze(parse_tree);
+  Status s = Analyze(parse_tree);
   if (s.IsQLError() && GetErrorCode(s) == ErrorCode::STALE_METADATA && !reparsed) {
     *parse_tree = nullptr;
     RETURN_NOT_OK(Parse(stmt, parse_tree, true /* reparsed */, mem_tracker));
-    return Analyze(parse_tree);
+    s = Analyze(parse_tree);
+  }
+  if (s.IsQLError()) {
+    RETURN_NOT_OK(audit_logger_.LogStatementError((*parse_tree)->root().get(), stmt, s,
+                                                  true /* error_is_formatted */));
   }
   return s;
 }
@@ -442,6 +451,7 @@ void QLProcessor::Reschedule(rpc::ThreadPoolTask* task) {
   // Some unit tests are not executed in CQL proxy. In those cases, just execute the callback
   // directly while disabling thread restrictions.
   const bool allowed = ThreadRestrictions::SetWaitAllowed(true);
+  audit_logger_.MarkRescheduled();
   task->Run();
   // In such tests QLProcessor is deleted right after Run is executed, since QLProcessor tasks
   // do nothing in Done we could just don't execute it.
diff --git a/src/yb/yql/cql/ql/ql_processor.h b/src/yb/yql/cql/ql/ql_processor.h
index 67b915c1fa05..91fe8c603c15 100644
--- a/src/yb/yql/cql/ql/ql_processor.h
+++ b/src/yb/yql/cql/ql/ql_processor.h
@@ -103,6 +103,9 @@ class QLProcessor : public Rescheduler {
   // Environment (YBClient) that processor uses to execute statement.
   QLEnv ql_env_;
 
+  // Used for logging audit records.
+  audit::AuditLogger audit_logger_;
+
   // Semantic analysis processor.
   Analyzer analyzer_;
 
